package ch03_oodesign;

/**
 * Beispielklasse zur Demonstration der Technik Immutable-Klasse
 * mit Java 14 Bordmitteln
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
record ImmutablePositionJdk14(int x, int y) 
{ 
    public ImmutablePositionJdk14 offset(final int xOffset, final int yOffset) 
    {
        return new ImmutablePositionJdk14(x + xOffset, y + yOffset); 
    }
    
    public static void main(String[] args) 
    {
    	ImmutablePositionJdk14 origin = new ImmutablePositionJdk14(0, 0);
    	System.out.println(origin);
    	
    	ImmutablePositionJdk14 pos42 = origin.offset(42, 42);
    	System.out.println(pos42);
    	
    	// 
    	System.out.println("Sames object? " + (origin == pos42));
	}
}