package ch03_oodesign.generics;

import java.time.LocalDate;

/**
 * Beispielprogramm zur Demonstration der Auswirkungen der Type Erasure
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2019 by Michael Inden 
 */
public class CompareArrayTspesExample 
{
	public static void main(String[] args) 
	{		
		final String[] nicknames = { "Dragonman", "Iron Mike", "Lordmaster" };
		final Person[] bowlingPeople = { new Person("Sven", LocalDate.now(), "Kiel"), 
		                                 new Person("Michael", LocalDate.now(), "Bremen"), 
		                                 new Person("Andreas", LocalDate.now(), "Kiel") };

		compareArrays(nicknames, bowlingPeople);		
	}

	private static void compareArrays(final String[] nicknames, final Person[] bowlingPeople) 
	{
		// $\mbox{\bfseries Compile-Error: Incompatible operand types Class<String[]> and Class<Person[]>}$
		// final boolean sameType1 = (String[].class == Person[].class);
		// final boolean sameType2 = (nicknames.getClass() == bowlingPeople.getClass());
		
		final boolean sameType3 = (nicknames.getClass().equals(
		                           bowlingPeople.getClass()));
		System.out.println(sameType3); // $\mbox{\bfseries false }$
	}
}
