package ch03_oodesign.generics;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

/**
 * Beispiel fr Typunsicherheiten ohne den Einsatz von Generics
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2019 by Michael Inden 
 */
public final class OldStyleList
{
    public static void main(final String[] args)
    {
        // Achtung: Nur zur Demonstration auf Generics verzichtet 
        final List personList = new ArrayList();
        personList.add(new Person("Max", LocalDate.now(), "Musterstadt"));
        personList.add(new Person("Moritz", LocalDate.now(), "Musterstadt"));
        personList.add(new Dog("Sarah vom Auetal"));

        for (int i = 0; i < personList.size(); i++)
        {
            // Explizite Typumwandlung notwendig zum Methodenaufruf
            final Person person = (Person) personList.get(i);
            System.out.println(person.getName() + " aus " + person.getCity());
        }
    }

    private OldStyleList()
    {
    }
}

class Dog
{
    private final String name;

    public Dog(final String name)
    {
        this.name = name;
    }

    @Override
    public String toString()
    {
        return "Dog [name='" + name + "']";
    }
}
