package ch03_oodesign.generics;

import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;

/**
 * Beispielprogramm zur Demonstration der Auswirkungen der Type Erasure
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2019 by Michael Inden 
 */
public final class TypeErasureExample
{
    public static void main(final String[] args)
    {
		final String[] nicknames = { "Dragonman", "Iron Mike", "Lordmaster" };
		final Person[] bowlingPeople = { new Person("Sven", LocalDate.now(), "Kiel"), 
		                                 new Person("Michael", LocalDate.now(), "Bremen"), 
		                                 new Person("Andreas", LocalDate.now(), "Kiel") };

        final List<String> nicknamesList = Arrays.asList(nicknames);
        final List<Person> bowlingPeopleList = Arrays.asList(bowlingPeople);

        // ACHTUNG: Compile-Error 
        // final boolean sameType1 = (List<String>.class == List<Person>.class);        
        final boolean sameType2 = (nicknamesList.getClass() == bowlingPeopleList.getClass());
        System.out.println(sameType2); // true 
    }
	
    private TypeErasureExample()
    {
    }
}
