package ch03_oodesign.varianz;

/**
 * Beispiel fr kovariante Rckgabewerte
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2020 by Michael Inden 
 */
public final class CovariantReturnExample
{
    public static void main(final String[] args)
    {
        final BaseFigure baseFigure = new CircleFigure(13);
        final CircleFigure circleFigure = new CircleFigure(7);
    
        final CircleFigure circleTypeCopy = circleFigure.copy(); // Kovariante Rckgabe 
        final double radius = circleTypeCopy.getRadius();
        System.out.println("radius of copy: " + radius); 
        
        // final CircleFigure circleTypeCopy = baseFigure.copy(); // Compile-Error 
    
        final BaseFigure baseCopy = baseFigure.copy();
        if (baseCopy instanceof CircleFigure)
        {
            final CircleFigure circleBaseCopy = (CircleFigure)baseCopy;
            System.out.println("baseCopy compile type BaseFigure");
            System.out.println("baseCopy runtime type CircleFigure");
            System.out.println("radius of copy: " + circleBaseCopy.getRadius()); 
        }
    }

    private CovariantReturnExample()
    {
    }
}

// Hilfsklassen usw. ... hier stark vereinfacht
abstract class BaseFigure
{
    abstract BaseFigure copy();
}

class CircleFigure extends BaseFigure
{
    private double radius;
    
    public CircleFigure(double radius)
    {
        this.radius = radius;
    }

    public CircleFigure copy()
    {
        return new CircleFigure(this.radius);
    }

    public double getRadius()
    {
        return radius;
    }
}

class RectFigure extends BaseFigure
{
    public RectFigure copy()
    {
        return new RectFigure();
    }
}