package ch04_lambdas;

import java.time.LocalDate;
import java.util.function.Predicate;

import ch05_javagrundlagen.Person;

/**
 * Beispielprogramm zur Demonstration der Formulierung einfacher Bedingungen mit Prdikaten.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2020 by Michael Inden 
 */
public class FirstPredicatesExample
{
public static void main(final String[] args)
{
    // Prdikate formulieren
    final Predicate<String> isNull = str -> str == null;
    final Predicate<String> isEmpty = String::isEmpty;
    final Predicate<Person> isAdult = person -> person.getAge() >= 18;

    final Person pia = new Person("Pia", LocalDate.of(1950, 1, 1), "London");
    System.out.println("isNull(''):     " + isNull.test(""));
    System.out.println("isEmpty(''):    " + isEmpty.test(""));
    System.out.println("isEmpty('Pia'): " + isEmpty.test(pia.getName()));
    System.out.println("isAdult(Pia):   " + isAdult.test(pia));
}
}