package ch06_collections.basics;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

import ch06_collections.Person;

/**
 * Beispielprogramm zur Demonstration des Interfaces Comparable.
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2014, 2019 by Michael Inden 
 */
public final class ComparableExample
{
    public static void main(String[] args)
    {
        final List<Person> customers = new ArrayList<>();

        customers.add(new Person("Mller", "Bremen", 27));
        customers.add(new Person("Mller", "Kiel", 37));
        customers.add(new Person("Meyer", "Oldenburg", 47));

        final Comparator<Person> naturalOrder = Comparator.naturalOrder();
        customers.sort(naturalOrder);

        final Comparator<Person> byName = (person1, person2) ->
                                 person1.getName().compareTo(person1.getName());
        customers.sort(naturalOrder);
        
        customers.forEach(currentPerson -> System.out.println(currentPerson));
    }
}