package ch06_collections.basics;
import java.util.Map;
import java.util.TreeMap;

/**
 * Beispielprogramm zur Demonstration der grundstzlichen Funktionalitt von Schlssel-Wert-Abbildungen und dem Interface Map
 * 
 * @author Michael Inden
 * 
 * Copyright 2014 by Michael Inden 
 */
public class FirstMapExample 
{
    // bewusst Fehler provozieren
    @java.lang.SuppressWarnings("squid:S4143")
	public static void main(final String[] args) 
	{
		final Map<String, Integer> nameToNumber = new TreeMap<>();
		nameToNumber.put("Micha", 4711);
		nameToNumber.put("Tim", 0714);
		nameToNumber.put("Jens", 1234);
		nameToNumber.put("Tim", 1508);
		nameToNumber.put("Ralph", 2208);

		System.out.println(nameToNumber);

		// Verschiedene Aktionen ausfhren
		System.out.println(nameToNumber.containsKey("Tim")); // Prfe Schlssel
		System.out.println(nameToNumber.get("Jens"));  // Zugriff per Schlssel
		System.out.println(nameToNumber.size());       // Anzahl der Eintrge
		System.out.println(nameToNumber.keySet());     // Alle Schlssel
		System.out.println(nameToNumber.values());     // Alle Werte
	}
}
