package ch06_collections.basics;

import java.util.Iterator;
import java.util.List;

/**
 * Beispielprogramm zur Demonstration der Neuerungen im Interface Iterator in JDK 8.
 * 
 * @author Michael Inden
 * 
 * Copyright 2019 by Michael Inden 
 */
public class IteratorForEachRemainingExample
{
    public static void main(String[] args)
    {
        var persons = List.of(new Person("Tim"), new Person("Tom"), new Person("Mike"));

        final Iterator<Person> it = persons.iterator();

        it.forEachRemaining(System.out::println);
    }
    
    static class Person
    {
        final String name;

        public Person(String name)
        {
            this.name = name;
        }

        @Override
        public String toString()
        {
            return "Person [name=" + name + "]";
        }
    }
}
