package ch06_collections.optional;

import java.util.List;
import java.util.Optional;

/**
 * Beispielprogramm zeigt, wie lesbar sich Alternativen mithilfe der Klasse Optional<T> beschreiben lassen.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2017 by Michael Inden 
 */
public class OptionalCalllerExample 
{
	private static List<Customer> customers = List.of(new Customer("Mike"), new Customer("Tim"));

	public static void main(String[] args) 
	{
		final String desiredName = "Unknown";

		final Optional<Customer> optCustomer = findCustomerByNameNewStyle(desiredName);
		optCustomer.ifPresentOrElse(cutomer -> printCustomerDetails(cutomer),
				() -> showWarnMessage("No such customer with name '" + desiredName + "'"));
	}

	public static Optional<Customer> findCustomerByNameNewStyle(final String name) {
		for (final Customer customer : customers) {
			if (customer.getName().equals(name)) {
				return Optional.of(customer);
			}
		}

		return Optional.empty();
	}

	private static void printCustomerDetails(Customer customer) {

	}

	private static void showWarnMessage(String string) {
		
	}	
}
