package ch07_stream_api;

import static java.util.stream.Collectors.joining;

import java.util.stream.IntStream;

/**
 * Beispielprogramm für die Bücher "Java Profi 4 / Java 9 -- Die Neuerungen"
 * 
 * @author Michael Inden
 * 
 * Copyright 2017 by Michael Inden 
 */
public class StreamsExample 
{
    public static void main(final String[] args) {
    
        final IntStream stream1 = IntStream.iterate(1, n -> n + 1);
        System.out.println("takeWhile:   " + stream1.takeWhile(n -> n < 10).
                                                     mapToObj(Integer::toString).
                                                     collect(joining(", ")));
    
        final IntStream stream2 = IntStream.rangeClosed(7,  14);
        System.out.println("dropWhile 1: " + stream2.dropWhile(n -> n < 10).
    	                                     mapToObj(Integer::toString).
    	                                     collect(joining(", ")));
    
        final IntStream stream3 = IntStream.of(7,9,11,13,15,5,3,1);
        System.out.println("dropWhile 2: " + stream3.dropWhile(n -> n < 10).
                                             mapToObj(Integer::toString).
                                             collect(joining(", ")));
    }
}
