package ch07_stream_api;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Stream;

/**
 * Beispielprogamm zeigt die Methode peek() zur Inspektion von Verarbeitungsschritten.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014-2019 by Michael Inden 
 */
public class WrongStreamInspectionExample
{
    public static void main(final String[] args)
    {
    	final List<Person> persons = Arrays.asList(new Person("Michael", 43),
                                                   new Person("Mike", 42));

        final Stream<Person> adults = persons.stream().filter(Person::isAdult);

        // Ausgabe, um die Filterung zu berprfen
        adults.forEach(System.out::println);

        final Stream<Person> allMikes = adults.filter(person ->
                                                      person.getName().equals("Mike"));
        allMikes.forEach(System.out::println);
    }
}
