package ch07_stream_api.advanced;

import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * Beispielprogramm zur Demonstration der Gruppierung
 * 
 * @author Michael Inden
 * 
 * Copyright 2017, 2020 by Michael Inden 
 */
public class GroupingExample
{
	public static void main(final String[] args)
	{
	   final String[] names = { "Tom", "Tim", "Mike", "Kay", "Micha", "Kai" };
	    
	   final Function<String, String> toFirstChar = 
			                          name -> name.substring(0, 1).toUpperCase();
			                          
	   var result = Stream.of(names).
			               collect(Collectors.groupingBy(toFirstChar));
	   System.out.println(result);
	}
}
