package ch07_stream_api.advanced;

import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * Beispielprogramm zur Demonstration der Aufbereitung eines Histogramms
 * 
 * @author Michael Inden
 * 
 * Copyright 2017, 2019 by Michael Inden 
 */
public class HistogramExample
{
public static void main(final String[] args)
{
   final Stream<String> names = 
		                Stream.of("tom", "Tim", "Mike", "Kai", "mike", "kai", "Kai", "TOM");
   
   final Map<String, Long> histogram = histogram(names, String::toLowerCase);
   System.out.println(histogram);
}
    
    public static <T> Map<T, Long> histogram(final Stream<T> stream,
                                             final Function<T, T> groupFunction)
    {
        return stream.collect(Collectors.groupingBy(groupFunction, Collectors.counting()));
    }
}
