package ch07_stream_api.terminal;

import java.util.Optional;
import java.util.function.BinaryOperator;
import java.util.stream.Stream;

/**
 * Beispielprogamm zeigt die Methode reduce() zur Berechnung von Ergebnissen.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2017, 2019 by Michael Inden 
 */
public class ReduceExample
{
    public static void main(final String[] args)
    {
        final Stream<String> names = Stream.of("Mike", "Tom", "Peter", "Chris");
        final Stream<Integer> integers = Stream.of(1, 2, 3, 4, 5, 6);

        final BinaryOperator<String> csvCombine = (str1, str2) -> str1 + ", " + str2;
        final BinaryOperator<Integer> multiply = (x, y) -> x * y;
        
		final Optional<String> stringConcat = names.reduce(csvCombine);
		final Optional<Integer> factorial = integers.reduce(multiply);

        System.out.println("stringConcat: " + stringConcat);
        System.out.println("factorial:    " + factorial);
    }
}