package ch09_applikationsbausteine.intro;

import org.apache.commons.lang3.StringUtils;

import com.google.common.base.Strings;

/**
 * Beispielklasse zur Demonstration der Funktionalitt aus Strings
 * 
 * @author Michael Inden
 * 
 *         Copyright 2020 by Michael Inden
 */
public class StringsIntroExample 
{
	public static boolean isValidString_Using_JDK(final String input) 
	{
		return input != null && !input.trim().isEmpty();
	}

	public static boolean isValidString_Using_JDK11(final String input) 
	{
		return input != null && !input.isBlank();
	}

	public static boolean isValidString_Using_Guava(final String input) 
	{
		return !Strings.isNullOrEmpty(input) && !input.trim().isEmpty();
	}

	public static boolean isValidString_Using_Commons(final String input) 
	{
		return StringUtils.isNotBlank(input);
	}
}