package ch09_applikationsbausteine.logging;

import java.util.concurrent.TimeUnit;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

/**
 * Beispiel fuer das Einlesen und Ueberwachen der log4j2-Konfiguration
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2014, 2017, 2019 by Michael Inden 
 */
public final class LogReadConfigExample
{
    private static final Logger LOGGER    = LogManager.getLogger(LogReadConfigExample.class);

    public static void main(final String[] args) throws InterruptedException
    {
        LOGGER.info("LogReadConfigExample started");

        while (!Thread.interrupted())
        {
            // Logge in alle Abstufungen; Filterung durch Anpassung
            // der Datei log4j.properties 
        	LOGGER.trace("TRACE");
            LOGGER.debug("DEBUG");
            LOGGER.info("INFO");
            LOGGER.warn("WARN");
            LOGGER.error("ERROR");
            LOGGER.fatal("FATAL");

            TimeUnit.SECONDS.sleep(2);
        }
    }
    

    private LogReadConfigExample()
    {
    }
}