package ch11_modern_concurrency.executors;

/**
 * Beispiel fr ein Runnable, dass Ein-und Ausgaben untersttzt
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2014, 2020 by Michael Inden 
 */
public class InputOutputRunnableExample<T1, T2, V> implements Runnable
{
    private final T1 input1;
	private final T2 input2;
	
	// zwar redundante Zuweisungen, helfen aber, die Wertebelegung klar darzulegen
	private V resultValue = null;
	private volatile boolean calculationFinished = false;

	public InputOutputRunnableExample(final T1 input1, final T2 input2)
	{
		this.input1 = input1;
		this.input2 = input2;
	}

	@Override
	public void run()
	{
		// Rcksetzen, falls mehrmals run() aufgerufen wird
		calculationFinished = false;

		resultValue = calculateResult(input1, input2);
		
		calculationFinished = true;		
	}

	public V getResult()
	{
		return resultValue;
	}

	public boolean isCalculationFinished()
	{
		return calculationFinished;
	}

	private V calculateResult(final T1 input1, final T2 input2)
	{
		return null;
	}
}