package ch11_modern_concurrency.executors;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

/**
 * Beispiel fr die Nutzung eines ScheduledExecutorService zur
 * zeitgesteuerten Ausfhrung von Aufgaben
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2014, 2017, 2020 by Michael Inden 
 */
public final class ScheduledExecutorExample
{
    public static void main(String[] args) throws InterruptedException
    {
        final int POOL_SIZE = 3;
        final ScheduledExecutorService executorService = Executors.newScheduledThreadPool(POOL_SIZE);

        // Sofortige Ausfhrung
        executorService.schedule(new SampleMessageTask("OnceImmediately"), 0, TimeUnit.SECONDS);

        // Ausfhrung nach fnf Sekunden 
        executorService.schedule(new SampleMessageTask("OnceAfter5s"), 5, TimeUnit.SECONDS);

        // Ausfhrung nach einer Minute 
        executorService.schedule(new SampleMessageTask("OnceAfter1min"), 1, TimeUnit.MINUTES);

		executorService.shutdown();
		executorService.awaitTermination(65, TimeUnit.SECONDS);
	}

    private ScheduledExecutorExample()
    {
    }
}
