package ch11_modern_concurrency.reactive_streams;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;

/**
 * Beispielprogramm für das Buch "Java 9 -- Die Neuerungen"
 * 
 * @author Michael Inden
 * 
 * Copyright 2017 by Michael Inden 
 */
public class WordFinderTwoSubscribersExample
{
    public static void main(final String[] args) throws IOException, InterruptedException
    {
        final WordPublisher finder = new WordPublisher("private", getInputFiles());
        finder.subscribe(new WordSubscriber());
        finder.subscribe(new First5Subscriber(System.err::println));
        finder.performSearch();

        Thread.sleep(2_000); // auf das Ende der Verarbeitung warten

        finder.terminate();
    }

    private static List<Path> getInputFiles()
    {
        final String srcPath = "src/main/resources/";
        return List.of(Paths.get(srcPath + "reactivestreams/WordPublisher.java"),
                       Paths.get(srcPath + "reactivestreams/WordFinderClient.java"));
    }
}
