package ch12_advancedjava.serializable;

import java.awt.Color;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.time.LocalDate;

/**
 * Beispielklasse zur Demonstration der Serialisierung einer Klasse, die das Externalizable-Interface erfllt.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2019 by Michael Inden
 */
public final class SerializationForExternalizableClassExample 
{
	public static void main(final String[] args) throws IOException, ClassNotFoundException 
	{
		final PersonExternalizable original = new PersonExternalizable("Test", "TestCity", LocalDate.now(), Color.GREEN);

        try (final ObjectOutputStream objectOutStream = new ObjectOutputStream(
             new BufferedOutputStream(new FileOutputStream("TestSerializationForExternalizableClass.ser"))))
        {
            // Schreibe Objekt in die Datei  
            objectOutStream.writeObject(original);
            System.out.println("Wrote to stream: " + original);
        }
	}

	private SerializationForExternalizableClassExample() 
	{
	}
}