package ch12_advancedjava.serializable.versioning;

import java.awt.Color;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.time.LocalDate;

/**
 * Beispielprogramm zur Demonstration zur Versionierung bei der Serialisierung
 *  
 * @author Michael Inden
 * 
 * Copyright 2019 by Michael Inden 
 */
public final class SerializationVersionsExample
{
    public static void main(final String[] args) throws IOException
    {
        final PersonVersion1 original = new PersonVersion1("Test", "TestCity", LocalDate.now());

        try (final ObjectOutputStream objectOutStream = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream("TestWithPersonVersion1.ser"))))
        {
            // Schreibe Objekt in die Datei  
            objectOutStream.writeObject(original);
            System.out.println("Wrote to stream: " + original);
        }
        
        final PersonVersion2 original2 = new PersonVersion2("Test", "TestCity", LocalDate.now(), Color.GREEN);

        try (final ObjectOutputStream objectOutStream = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream("TestWithPersonVersion2.ser"))))
        {
            // Schreibe Objekt in die Datei  
            objectOutStream.writeObject(original2);
            System.out.println("Wrote to stream: " + original);
        }
    }

    private SerializationVersionsExample()
    {
    }
}