package ch13_i18n.basics;

import java.text.MessageFormat;
import java.text.ParseException;
import java.time.LocalDate;

/**
 * Beispielklasse zur Demonstration der Formatierung von Texten mit der Klasse MessageFormat
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2017, 2019 by Michael Inden 
 */
public final class MessageFormatExample
{
public static void main(final String[] args) throws ParseException
{
    final String textTemplate = "Am {1} ist {0}. {2} Sekt bitte {4}!";
    final MessageFormat messageFormat = new MessageFormat(textTemplate);

    final Object[] arguments = { "Karneval",
    		                     LocalDate.of(2019, 11, 11), 3 };
    final String formattedText = messageFormat.format(arguments);

    System.out.println("Eingabe: " + textTemplate);
    System.out.println("Formatiert: " + formattedText);
}

    private MessageFormatExample()
    {
    }
}
