package ch14_java12_15;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

/**
 * Beispielklasse fr das Buch "Der Weg zum Java-Profi"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class FilesMismatchExample
{
    public static void main(final String[] args) throws IOException
    {
        compareSameContent();
        compareDifferentContent();
    }
    
    private static void compareSameContent() throws IOException 
    {
    	Path filePath1 = Files.createTempFile("test1", ".txt");
        Path filePath2 = Files.createTempFile("test2", ".txt");
        
        Files.writeString(filePath1, "Same Content");
        Files.writeString(filePath2, "Same Content");
    
        long pos = Files.mismatch(filePath1, filePath2);
        System.out.println("Same content: mismatch(File1, File2) = " + pos);  
    }
    
    private static void compareDifferentContent() throws IOException 
    {
    	Path filePath1 = Files.createTempFile("test1", ".txt");
        Path filePath2 = Files.createTempFile("test2", ".txt");
        
        Files.writeString(filePath1, "Same Content");
        Files.writeString(filePath2, "Same Start / Different Content");
        
        long pos = Files.mismatch(filePath1, filePath2);
        System.out.println("Different content: mismatch(File1, File2) = " + pos);
    } 
}

