package ch14_java12_15;

import java.text.NumberFormat;
import java.util.Locale;

/**
 * Beispielklasse fr das Buch "Der Weg zum Java-Profi"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class FirstCompactNumberFormatExample
{
    public static void main(final String args[]) 
    {
        var shortFormat = getUsCompactNumberFormat(NumberFormat.Style.SHORT);
        formatNumbers("SHORT", shortFormat);
    
        var longFormat = getUsCompactNumberFormat(NumberFormat.Style.LONG);
        formatNumbers("LONG", longFormat);
    }
    
    private static NumberFormat getUsCompactNumberFormat(NumberFormat.Style style) 
    {
        return NumberFormat.getCompactNumberInstance(Locale.US, style);
    }
    
    private static void formatNumbers(final String style,
                                      final NumberFormat format) 
    {
        System.out.println("\nNumberFormat " + style);
        System.out.println("Result: " + format.format(10_000));
        System.out.println("Result: " + format.format(123_456));
        System.out.println("Result: " + format.format(1_234_567));
        System.out.println("Result: " + format.format(1_950_000_000));
    }
}

