package ch14_java12_15;

/**
 * Beispielklasse fr das Buch "Der Weg zum Java-Profi"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class LocalEnumsAndInterfacesExamples
{
    public String UNUSED = "??";
    
    public static void main(String[] args)
    {
        evaluate();
    }

    private static void evaluate()
    {
        // Erst ab Java 15, vorher Compile-Error:
        // Local enums are not supported at language level '14'
        enum LocalEnum
        {
            BAD, GOOD, UNKNOWN
        }

        // Erst ab Java 15, vorher Compile-Error:
        // Local interfaces are not supported at language level '14'
        interface Scorer
        {
            LocalEnum evaluate(String info);
        }

        class AlwaysBad implements Scorer
        {
            @Override
            public LocalEnum evaluate(String info)
            {
                return LocalEnum.BAD;
            }
        }

        System.out.println(new AlwaysBad().evaluate("DOES NOT MATTER"));
    }
}
