package ch14_java12_15;

import java.text.NumberFormat;
import java.text.NumberFormat.Style;
import java.text.ParseException;
import java.util.Locale;

/**
 * Beispielklasse fr das Buch "Der Weg zum Java-Profi"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class SecondCompactNumberFormatExample
{
    public static void main(final String[] args) throws ParseException 
    {
    	System.out.println("US/SHORT parsing:");
    	var shortFormat = NumberFormat.getCompactNumberInstance(Locale.US, 
    	                                                        Style.SHORT);
    	System.out.println(shortFormat.parse("1 K")); // ACHTUNG: wird als 1 erkannt
        System.out.println(shortFormat.parse("1K"));
        System.out.println(shortFormat.parse("1M"));
        System.out.println(shortFormat.parse("1B"));
    
        System.out.println("\nUS/LONG parsing:");
        var longFormat = NumberFormat.getCompactNumberInstance(Locale.US, 
                                                               Style.LONG);
        System.out.println(longFormat.parse("1 thousand"));
        System.out.println(longFormat.parse("1 million"));
        System.out.println(longFormat.parse("1 billion"));
    }
}

