package ch14_java12_15;

import java.time.LocalDate;

/**
 * Beispielklasse fr das Buch "Der Weg zum Java-Profi"
 * 
 * @author Michael Inden
 * 
 *         Copyright 2020 by Michael Inden
 */
public class SomeRecordsExample {

	record TopLeftWidthAndHeight(MyPoint topLeft, int width, int height) {
	}

	record Rectangle(int x, int y, int width, int height) {
		Rectangle(TopLeftWidthAndHeight pointAndDimension) {
			this(pointAndDimension.topLeft().x, pointAndDimension.topLeft().y, pointAndDimension.width,
					pointAndDimension.height);
		}
	}

	record MyPoint(int x, int y) {
		public MyPoint(String values) {
			this(Integer.parseInt(values.split(",")[0]), Integer.parseInt(values.split(",")[1]));
		}

		public String shortForm() {
			return "[" + x + ", " + y + "]";
		}
	}

	record ColorAndRgbDTO(String name, int red, int green, int blue) {
	}

	record PersonDTO(String firstname, String lastname, LocalDate birthday) {
	}

	public static void main(String[] args) {
		var oldStyle = new Rectangle(17, 19, 70, 30);

		var topLeft = new MyPoint(17, 19);
		System.out.println(topLeft);
		System.out.println(topLeft.shortForm());
		var newStyle = new Rectangle(new TopLeftWidthAndHeight(topLeft, 60, 20));
	}
}
