package ch14_java12_15;

import static java.util.stream.Collectors.counting;
import static java.util.stream.Collectors.summingLong;
import static java.util.stream.Collectors.teeing;

import java.util.stream.Stream;

/**
 * Beispielklasse fr das Buch "Der Weg zum Java-Profi"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class TeeingCollectorExample
{
    public static void main(final String[] args)
    {
        System.out.println(calcCountAndSum(Stream.of(1, 2, 3, 4, 5, 6)));

        System.out.println(calcCountAndSum(Stream.of(1, 3, 5, 7, 11, 13, 17)));
    }

    private static LongPair calcCountAndSum(Stream<Integer> numbers) 
    {
        return numbers.collect(teeing(
                                      counting(),
                                      summingLong(n -> n),
                                      (count, sum) -> new LongPair(count, sum))); 
    }
    
    record LongPair(long count, long sum)
    {        
    }
}
