package ch16_badsmells;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;

public final class VarDeclaration
{
    private static final Image NO_IMAGE = new BufferedImage(0, 0, BufferedImage.TYPE_INT_RGB);
    private static final int DEFAULT_IMAGE_OFFSET = 7;
    private static final List<String> imageNames = new ArrayList<String>();
    private static final List<Image> images  = new ArrayList<Image>();
    
// linksb?ndig im Buch
private static Image getImageForName(final String imageNameToSearch)
{
    boolean found = false;
    String imageName = null;
    Image image = null;
    int index = 0;

    for (int i = 0; i < imageNames.size() && found == false; i++)
    {
        imageName = imageNames.get(i);
        if (imageName.equalsIgnoreCase(imageNameToSearch))
        {
            found = true;
            index = i + DEFAULT_IMAGE_OFFSET;
            image = images.get(index);
        }
    }

    return (found ? image : NO_IMAGE);
}

// linksb?ndig im Buch
private static Image getImageForNameImproved(final String imageNameToSearch)
{
    for (int i = 0; i < imageNames.size(); i++)
    {
        final String imageName = imageNames.get(i);
        if (imageName.equalsIgnoreCase(imageNameToSearch))
        {
            return images.get(i + DEFAULT_IMAGE_OFFSET);
        }
    }

    return NO_IMAGE;
}
}