package ch17_refactorings.basics;

import java.time.LocalDateTime;

/**
 * Beispielprogramm fr die Bcher "Java Profi 5 / Java 9 -- Die Neuerungen"
 * 
 * @author Michael Inden
 * 
 * Copyright 2017 by Michael Inden 
 */
public enum SupportedFrequencies 
{
   MONTHLY
   {
      @Override
	public String createTimeStampString(final LocalDateTime start)
      {
         return start.getYear() + "-" + start.getMonthValue();
      }
   }, 

   QUARTERLY
   {
      @Override
	public String createTimeStampString(final LocalDateTime start)
      {
         return start.getYear() + "-Q" + (1 + (start.getMonthValue() - 1) / 3);   
      }
   };

   public abstract String createTimeStampString(final LocalDateTime start);
}