package ch17_refactorings.basics;

import java.time.LocalDateTime;

/**
 * Beispiel fr eine Kombination von Basis-Refactorings
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2014, 2020 by Michael Inden 
 */
public class TimeStampUtils 
{
	public static String createTimeStampString(final MyTimePeriod currentPeriod, 
					                           final MyFrequency frequency) 
	{
		final LocalDateTime start = currentPeriod.getDateTime();

		final int divisor = frequency == MyFrequency.P1M ? 1 : 3;
		final String addition = frequency == MyFrequency.P1M ? "" : "Q";
		final int value = ((start.getMonthValue() - 1) / divisor + 1);

		return start.getYear() + "-" + addition + value;
	}
}
