package ch17_refactorings.basics;

import java.time.LocalDateTime;

/**
 * Beispiel fr eine Kombination von Basis-Refactorings, Schritt 1
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2014 by Michael Inden 
 */
public class TimeStampUtilsStep1 
{
	public static String createTimeStampString(final MyTimePeriod currentPeriod, 
	                                            final MyFrequency frequency) 
	{
		final LocalDateTime start = currentPeriod.getDateTime();
		
		final boolean isMonthly = frequency == MyFrequency.P1M;
		final int divisor = isMonthly ? 1 : 3;
		final String addition = isMonthly ? "" : "Q";
		final int value = ((start.getMonthValue() - 1) / divisor + 1);
	
		return start.getYear() + "-" + addition + value;
	}
}

