package ch20_unittests.basics;

import com.google.common.base.Preconditions;

/**
 * Beispiel einer Rabattberechnung: Verbesserte dritte Variante
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class DiscountCalculatorV4
{
	public Discount calcDiscount(final int count)
	{
		Preconditions.checkArgument(count >= 0, "count should not be negative");
		
		if (count < 50)
			return Discount.NO_DISCOUNT;
		if (count >= 50 && count <= 1000)
			return Discount.MEDIUM_DISCOUNT;
		if (count > 1000)
			return Discount.BIG_DISCOUNT;

		throw new IllegalStateException("programming problem: should never " +
                         "reach this line. value " + count + " not handled!");
	}
}
