package ch20_unittests.basics;

import java.util.List;
import java.util.Objects;

/**
 * Beispiel einer Rabattberechnung: Verbesserte zweite Variante
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2017, 2020 by Michael Inden 
 */
public class SumWithOffsetCalculator 
{
	private final int offset;

	public SumWithOffsetCalculator(final int offset)
	{
		this.offset = offset;
	}
 
	public int getOffset()
	{
		return offset;
	}
	
	public long sum_with_offset(final List<Integer> values)
	{
		//Preconditions.checkNotNull(elements, "parameter 'elements' must not be null");
		//Preconditions.checkArgument(elements != null, "parameter 'elements' must not be null");
		Objects.requireNonNull(values, "parameter 'values' must not be null");
		
		return values.stream().mapToLong(value -> value).sum()  + offset;
	}
}