package ch22_optimierungen.datastructures;

import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.stream.Collectors;

import ch03_oodesign.generics.Person;

/**
 * Beispielprogramm 
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public final class AccessApiDesignExample
{
    private List<Person> persons = List.of();
    
    public Set<String> getCitySet()
    {
        final Set<String> resultSet = new TreeSet<>();

        for (final Person person : persons)
        {
            resultSet.add(person.getCity());
        }

        return resultSet;
    }
    
    public Set<String> getCitySet_Streams()
    {
        return persons.stream().
                       map(Person::getCity).
                       collect(Collectors.toSet());
    }
    

    private AccessApiDesignExample()
    {
    }
}