package ch99_swing_gui.painting_in_components;

import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.WindowConstants;
import javax.swing.border.Border;

/**
 * Beispielprogramm zur Demonstration der Klasse Border fr Umrahmungen von GUI-Komponenten. 
 * <br>
 * <b>Auflage 2</b>
 * 
 * @author Michael Inden
 * 
 * Copyright 2012 by Michael Inden
 */
public final class JLabelWithCompoundBorderExample
{
    public static void main(final String[] args)
    {
        final JFrame frame = new JFrame("JLabelWithCompoundBorderExample");
        frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

        final JLabel label = new JLabel("Text mit zwei Rndern vom Typ Border");

        // Verschiedene Umrahmungen erzeugen  
        final Border blueBorder = BorderFactory.createLineBorder(Color.BLUE, 5);
        final Border titledBorder = BorderFactory.createTitledBorder("Title");
        final Border compoundBorder = BorderFactory.createCompoundBorder(
                                                     titledBorder, blueBorder);

        // Umrahmungen mit dem JLabel verkn�pfen  
        label.setBorder(compoundBorder);

        frame.add(label);
        frame.setSize(350, 90);
        frame.setVisible(true);
    }
    
    private JLabelWithCompoundBorderExample()
    {        
    }
}