package ch02_profbuild;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertNull;
import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.junit.jupiter.api.Test;

/**
 * Beispiel fuer verschiedene assert()-Methoden
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2014, 2019 by Michael Inden 
 */
public class JUnit5ExampleTest
{
    @Test
    public void testAssertTrue()
    {
        final List<String> names = new ArrayList<>(); 
        names.add("Max");
        names.add("Moritz");
        names.clear();
        assertTrue(names.isEmpty());
    }
    
    @Test
    public void testAssertFalse()
    {
        final List<Integer> primes = Arrays.asList(2, 3, 5, 7);
		// Hier wird bewusst ein Fehler provoziert 
        assertFalse(primes.contains(7));
    }

    @Test
    public void testAssertNull()
    {
        assertNull(null);        
    }
    
    @Test
    public void testAssertNotNull()
    {
        // Hier wird bewusst ein Fehler provoziert 
        assertNotNull(null, "Unexpected null value");
    }

    @Test
    public void testAssertEquals()
    {
        assertEquals("EXPECTED", "expected".toUpperCase());
    }

    @Test
    public void testAssertEqualsWithPrecision()
    {
        assertEquals(2.75, 2.74999, 0.1);
    }
    
    @Test
    public void testFailWithExceptionJUnit5()
    {
    	assertThrows(java.lang.NumberFormatException.class, () ->
    	{
    		// Hier wird bewusst ein Fehler provoziert
    		final int value = Integer.parseInt("Fehler simulieren!");
    	});
    }      
}
