package ch17_refactorings.basics;

import static ch17_refactorings.basics.TimeStampUtilsStepFinal.createTimeStampString;
import static org.junit.jupiter.api.Assertions.assertEquals;

import java.time.LocalDateTime;

// JUnit 4 fr Web-Anzeige
import org.junit.Test;

/**
 * Beispiel fr einfache Testflle
 *  
 * @author Michael Inden
 * 
 * Copyright 2014, 2020  by Michael Inden 
 */
public class TimeStampUtilsTest 
{
	@Test
	public void test_createTimeStampString_Monthly()
	{
		final boolean MONTHLY = true;
		assertEquals("2000-2", createTimeStampString(LocalDateTime.of(2000, 2, 7, 0, 0), MONTHLY));
		assertEquals("2000-7", createTimeStampString(LocalDateTime.of(2000, 7, 14, 0, 0), MONTHLY));
		assertEquals("2000-12", createTimeStampString(LocalDateTime.of(2000, 12, 24, 0, 0), MONTHLY));
	}
	
	@Test
	public void test_createTimeStampString_Quarterly()
	{
		final boolean QUARTERLY = false;
		assertEquals("2000-Q1", createTimeStampString(LocalDateTime.of(2000, 2, 7, 0, 0), QUARTERLY));
		assertEquals("2000-Q3", createTimeStampString(LocalDateTime.of(2000, 7, 14, 0, 0), QUARTERLY));
		assertEquals("2000-Q4", createTimeStampString(LocalDateTime.of(2000, 12, 24, 0, 0), QUARTERLY));
	}
}
