package ch20_unittests.basics;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.Test;

/**
 * Unit-Tests zu der Utility-Klasse DiscountCalculatorV1.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2019 by Michael Inden 
 */
public class DiscountCalculatorV1Test 
{
	private final DiscountCalculatorV1 calculator = new DiscountCalculatorV1();
	
	@Test
	void testCalcDiscount_SmallOrder_NoDiscount() 
	{
		final int smallAmount = 20;
		assertEquals(0, calculator.calcDiscount(smallAmount), "no discount");
	}

	@Test
	void testCalcDiscount_MediumOrder_MediumDiscount() 
	{
		final int mediumAmount = 200;
		assertEquals(4, calculator.calcDiscount(mediumAmount), "4 % discount");
	}

	@Test
	void testCalcDiscount_BigOrder_BigDiscount() 
	{
		final int bigAmount = 2000;
		assertEquals(7, calculator.calcDiscount(bigAmount), "7 % discount");
	}
}
