package ch20_unittests.basics;


import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.Test;

/**
 * Unit-Tests zu der Utility-Klasse DiscountCalculatorV1.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2017, 2019 by Michael Inden 
 */
class DiscountCalculatorV1Test_CornerCases 
{
	private final DiscountCalculatorV1 calculator = new DiscountCalculatorV1();
	
	@Test
	void testCalcDiscount_SmallOrder_NoDiscount() 
	{
		final int smallAmount = 20;
		assertEquals(0, calculator.calcDiscount(smallAmount), "No discount");
	}

	@Test
	void testCalcDiscount_MediumOrder_MediumDiscount() 
	{
		final int mediumAmount = 200;
		assertEquals(4, calculator.calcDiscount(mediumAmount), "4 % discount");
	}

	@Test
	void testCalcDiscount_BigOrder_BigDiscount() 
	{
		final int bigAmount = 2000;
		assertEquals(7, calculator.calcDiscount(bigAmount), "7 % discount");
	}

	// Randflle prfen
	
	@Test
	void testCalcDiscount_Input_49_ShouldHaveNoDiscount() 
	{
		assertEquals(0, calculator.calcDiscount(49), "No discount");
	}
	
	@Test
	void testCalcDiscount_Input_50_ShouldHaveMediumDiscount() 
	{
		assertEquals(4, calculator.calcDiscount(50), "4 % discount");
	}
	
	@Test
	void testCalcDiscount_Input_51_ShouldHaveMediumDiscount() 
	{
		assertEquals(4, calculator.calcDiscount(51), "4 % discount");
	}

	@Test
	void testCalcDiscount_Input_999_ShouldHaveMediumDiscount() 
	{
		assertEquals(4, calculator.calcDiscount(999), "4 % discount");
	}

	@Test
	void testCalcDiscount_Input_1000_ShouldHaveMediumDiscount() 
	{
		assertEquals(4, calculator.calcDiscount(1000), "4 % discount");
	}

	@Test
	void testCalcDiscount_Input_1001_ShouldHaveBigDiscount() 
	{
		assertEquals(7, calculator.calcDiscount(1001), "7 % discount");
	}
}
