package ch20_unittests.basics;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

/**
 * Unit-Tests zu der Utility-Klasse DiscountCalculatorV2.
 * 
 * @author Michael Inden
 * 
 *         Copyright 2014, 2107, 2019, 2020 by Michael Inden
 */
public class DiscountCalculatorV2AsParameterizedTest 
{
	private final DiscountCalculatorV2 calculator = new DiscountCalculatorV2();

	@ParameterizedTest(name = "{index}: amount {0} => discount {1}")
	@CsvSource({ "20, 0", "200, 4", "2000, 7" })
	void testCalcDiscount_EquivalenceClasses(final int amount, final int expectedDiscount) 
	{
		assertEquals(expectedDiscount, calculator.calcDiscount(amount));
	}

	@ParameterizedTest(name = "{index}: amount {0} => discount {1}")
	@CsvSource({ "49, 0", "50, 4", "51, 4", 
		         "999, 4", "1000, 4", "1001, 7" })
	void testCalcDiscount_CornerCases(final int amount, final int expectedDiscount) 
	{
		assertEquals(expectedDiscount, calculator.calcDiscount(amount));
	}
}
