package ch20_unittests.basics;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

/**
 * Besipiel eines Unit Tests mit JUnit 5
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class StrangeMultiInits 
{
	static String global;
	
	int i;
	double d;
	
	@BeforeAll
	static void initGlobal()
	{
		global = "STATIC VALUE";
	}
	
	@BeforeEach
	void initInt()
	{
		i = 42;
	}
	
	@BeforeEach
	void initDouble()
	{
		d = 25375d;
		// auch möglich, i wird aber nicht gesetzt ...
		i = 13;
	}
	
	@Test
	@DisplayName("strange 😱😱😱😱😱😱 setup with @Before")
	public void strangeTestFixtureSetup() 
	{
		assertEquals("STATIC VALUE", global);
		assertEquals(42, i);
		assertEquals(25375, d, 0.1);
	}
}
