package ch20_unittests.ch20_3_misc;

import static org.junit.jupiter.api.Assertions.assertAll;
import static org.junit.jupiter.api.Assertions.assertEquals;

import java.time.LocalDate;

import org.junit.jupiter.api.Test;

/**
 * Besipiel eines Unit Tests mit JUnit 5
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class AssertAllTest 
{
	@Test
	void multipleAssertsforOneTopic_Diff1() 
	{
		Person mike = new Person("Mike", LocalDate.of(1971, 2, 7), "Zrich");
		
		assertEquals("Tim", mike.name);
		assertEquals(LocalDate.of(1971, 3, 27), mike.dateOfBirth);
		assertEquals("Kiel", mike.homeTown);
	}
	
	@Test
	void multipleAssertsforOneTopic_Diff2() 
	{
		Person mike = new Person("Mike", LocalDate.of(1971, 2, 7), "Zrich");
		
		assertAll(() -> assertEquals("Tim", mike.name), 
				  () -> assertEquals(LocalDate.of(1971, 3, 27), mike.dateOfBirth),
				  () -> assertEquals("Kiel", mike.homeTown));
	}
	
	
	record Person(String name, LocalDate dateOfBirth, String homeTown)
	{		
	}
}
