package ch20_unittests.ch20_3_misc;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

/**
 * Unit-Tests zur Demonstration von @DisplayName
 * 
 * @author Michael Inden
 * 
 * Copyright 2019 by Michael Inden
 */
public class DisplayNameTest 
{
	@Test
	@DisplayName("This is a name with unicode \u1234")
	public void changeMyName() {
		assertTrue(true, "name is changed to taht of @DisplayName");
	}
	
	@Test
	@DisplayName("Simple Math: (1 * 2 * 3) / 4 = 6/4 = 3/2 = 1.5")
	void divideResultOfMultiplication()
	{
		assertEquals((1 * 2 * 3) / 4d, 1.5, 0.1);
	}
	
	@Test
	@DisplayName("GET 'http://localhost:8080/products/4711' user: Peter Müller")
	public void getProductFor4711()
	{
		// ..
	}
	
	@Test
	@DisplayName("🙂😱")
	public void injectParams() {
		assertTrue(true, "using emoijis");
	}
}
