package ch20_unittests.ch20_3_misc;

import static org.junit.jupiter.api.Assertions.assertEquals;

import java.util.Set;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Tag;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInfo;

/**
 * Unit-Tests zur Demonstration der Mglichkeiten Metainformationen abzufragen
 * 
 * @author Michael Inden
 * 
 * Copyright 2019 by Michael Inden 
 */
public class InjectionOfMetaDataTest 
{
    @Test
    @DisplayName("unicode \u1234") 
    @Tag("very")
    @Tag("special")
    public void injectParams(final TestInfo testInfo) 
    {
        assertEquals("injectParams", testInfo.getTestMethod().get().getName());
        assertEquals("unicode \u1234", testInfo.getDisplayName());
        assertEquals(Set.of("very", "special"), testInfo.getTags());
    }
}
