package ch20_unittests.ch20_3_misc;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

/**
 * Unit-Tests zur Demonstration von Parametrized Tests
 * 
 * @author Michael Inden
 * 
 * Copyright 2019 by Michael Inden 
 */
public class ParametrizedTestExample
{
	@ParameterizedTest(name = "{index}: hexInput {0} => value {1}")
	@CsvSource({"'0', 0", "'1', 1", "'2', 2", "'3', 3", "'4', 4", 
		        "'5', 5", "'6', 6", "'7', 7", "'8', 8", "'9', 9", 
	            "'A',10", "'B',11", "'C',12", "'D',13", "'E',14", "'F',15"}) 
	public void testHexCodedByteValueToInt_AllValidInputs(final char input, final int expected)	
	{
		assertEquals(expected, Controller.hexCodedByteValueToInt((byte)input));
	}
}