package ch20_unittests.ch20_3_misc;

import static org.junit.jupiter.api.Assertions.assertEquals;

import java.util.stream.Stream;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;

/**
 * Unit-Tests zur Demonstration von Parametrized Tests
 * 
 * @author Michael Inden
 * 
 * Copyright 2019 by Michael Inden 
 */
public class ParametrizedTestWithMethodSourceExample 
{	
	@ParameterizedTest(name = "{index}: hexInput {0} => value {1}")
	@MethodSource("createHexAndValue")
	public void testHexCodedByteValueToInt_With_AllValidInputs(final char input, final int expected)	
	{
		assertEquals(expected, Controller.hexCodedByteValueToInt((byte)input));
	}
	
	private static Stream<Arguments> createHexAndValue() 
	{
		return Stream.of(Arguments.of('0', 0), Arguments.of('1', 1), 
				         Arguments.of('2', 2), Arguments.of('A', 10),
				         Arguments.of('E', 14), Arguments.of('F', 15));
	}
}