package ch20_unittests.ch20_3_misc;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.File;
import java.io.IOException;
import java.util.Set;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.io.TempDir;

/**
 * Besipiel eines Unit Tests mit JUnit 5
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class TempDirTest 
{
   @Test
   public void testUsingTempFolder(@TempDir File folder) throws IOException 
   {
      // Ermittle den Inhalt des Temp-Folders, normales File-API  
      final String[] dirContentsInitial = folder.list();
      assertEquals(0, dirContentsInitial.length);

      final File subFolder = new File(folder, "subfolder");
      subFolder.mkdir();
      final File createdFile = new File(folder, "abc.txt");
      createdFile.createNewFile();
      
      // Ermittle den Inhalt des Temp-Folders, normales File-API  
      final String[] dirContents = folder.list();
		
      // Prfe, ob File existiert und Verzeichnisinhalt bereinstimmt  
      // Als Menge, damit die Reihenfolge keinen Einfluss hat  
      assertTrue(createdFile.exists());
      assertEquals(Set.of("subfolder", "abc.txt"), Set.of(dirContents));
   }
}