package ch20_unittests.ch20_4_parameterized_tests;

import static org.junit.jupiter.api.Assertions.assertEquals;

import java.time.LocalDate;
import java.time.temporal.ChronoUnit;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.converter.ConvertWith;
import org.junit.jupiter.params.provider.CsvSource;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class ArgumentConverrterTest
{
    @ParameterizedTest
    @CsvSource(value = { "{ name:'Peter', dateOfBirth: '2012-12-06', homeTown : 'Kln'} | false",
                         "{ name:'Mike', dateOfBirth: '1971-02-07', homeTown : 'Zrich'} | true" }, delimiter = '|')
    void jsonPersonAdultTest(@ConvertWith(JsonToPerson.class) Person person, boolean expected)
    {
        final long age = ChronoUnit.YEARS.between(person.dateOfBirth(), LocalDate.now());

        assertEquals(expected, age >= 18);
    }
}
