package ch20_unittests.ch20_4_parameterized_tests;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class CsvSourceIntroTest
{
    @ParameterizedTest(name = "reverse({0}) => {1}")
    @CsvSource({ "ABCD, DCBA", "OTTO, OTTO", "PETER, RETEP" })
    void testReverse(final String input, final String expectedOutput)
    {
        final String result = new StringBuilder(input).reverse().toString();

        assertEquals(expectedOutput, result);
    }

    @ParameterizedTest(name = "{index}: {0} + {1} = {2}")
    @CsvSource({ "1, 1, 2", "2, -2, 0", "3, 4, 7" })
    void testAdd(int first, int second, int expected)
    {
        int sum = first + second;

        assertEquals(expected, sum);
    }
}
