package ch20_unittests.ch20_4_parameterized_tests;

import static org.junit.jupiter.api.Assertions.assertAll;
import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertThrows;

import java.time.LocalDate;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.function.Executable;

import ch20_unittests.ch20_4_parameterized_tests.CornerCasesTest.DateRange;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class DateRangeImprovedTest 
{
	/*
	@ParameterizedTest(name = "validateDateRange({0} => {1}")
	@MethodSource("allCombinations")
	void validateDateRangeConstruction(LocalDate from, 
			                           LocalDate to, 
			                           Class<? extends Throwable> expectedException) {
		if (expectedException != null)
			assertThrows(expectedException, () -> new DateRange(from, to));
		else
			assertNotNull(new DateRange(from, to));
	}

	static Stream<Arguments> allCombinations() 
	{
		return Stream.of(Arguments.of(null, LocalDate.now(), null), 
				         Arguments.of(LocalDate.now(), null, null),
				         Arguments.of(null, null, IllegalArgumentException.class));
	}
	*/

	@Test
	void testInvalidDateRangeConstruction() 
	{
		final Executable action = () -> new DateRange(null, null);
		
		assertThrows(IllegalArgumentException.class, action);
	}
	
	@Test
	void validateDateRangeConstruction()
	{
		assertAll(()-> assertNotNull(new DateRange(null, LocalDate.now())),
				  ()-> assertNotNull(new DateRange(LocalDate.now(), null)));
	}
}
