package ch20_unittests.ch20_4_parameterized_tests;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

import ch20_unittests.basics.DiscountCalculatorV3;

/**
 * Unit-Tests zu der Utility-Klasse DiscountCalculatorV2.
 * 
 * @author Michael Inden
 * 
 *         Copyright 2014, 2107, 2019, 2020 by Michael Inden
 */
public class DiscountCalculatorV2ParameterizedTest 
{
	private final DiscountCalculatorV3 calculator = new DiscountCalculatorV3();

	@ParameterizedTest(name = "{index}: amount {0} => discount {1}")
	@CsvSource({ "20, 0", "200, 4", "2000, 7" })
	void testCalcDiscount_EquivalenceClasses(final int amount, final int expectedDiscount) 
	{
		assertEquals(expectedDiscount, calculator.calcDiscount(amount));
	}

	@ParameterizedTest(name = "{index}: amount {0} => discount {1}")
	@CsvSource({ "49, 0", "50, 4", "51, 4", 
		         "999, 4", "1000, 4", "1001, 7" })
	void testCalcDiscount_CornerCases(final int amount, final int expectedDiscount) 
	{
		assertEquals(expectedDiscount, calculator.calcDiscount(amount));
	}
}
