package ch20_unittests.ch20_4_parameterized_tests;

import org.junit.jupiter.api.extension.ParameterContext;
import org.junit.jupiter.params.converter.ArgumentConversionException;
import org.junit.jupiter.params.converter.ArgumentConverter;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
class HexToInt implements ArgumentConverter
{
    @Override
    public Object convert(Object source, ParameterContext context) 
           throws ArgumentConversionException
    {
        try
        {
           return Integer.parseInt((String) source, 16);
        }
        catch (final NumberFormatException e)
        {
           throw new ArgumentConversionException("invalid value: " + source, e);
        }
    }
}