package ch20_unittests.ch20_4_parameterized_tests;

import java.io.IOException;
import java.time.LocalDate;

import com.google.gson.TypeAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
final class LocalDateAdapter extends TypeAdapter<LocalDate>
{
    @Override
    public void write(final JsonWriter jsonWriter, final LocalDate localDate) throws IOException
    {
        jsonWriter.value(localDate.toString());
    }

    @Override
    public LocalDate read(final JsonReader jsonReader) throws IOException
    {
        return LocalDate.parse(jsonReader.nextString());
    }
}