package ch20_unittests.ch20_5_advanced.extractandoverride.complex;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

import org.junit.jupiter.api.Test;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class PizzaServiceV2Test 
{
	@Test
	public void orderPizza_should_send_sms()
	{
		// Arrange
		final StubNotificationService stub = new StubNotificationService();
		final PizzaServiceV2 service = new PizzaServiceV2()
		{
			@Override
			protected SmsNotificationService createNotificationService()
			{
				return stub;
			}
		};
		
		// Act
		service.orderPizza("Diavolo");
		service.orderPizza("Surprise");
		
		// Assert  
		assertEquals(2, stub.getMessages().size());
		assertTrue(stub.getMessages().
		           contains("Pizza Diavolo wird in Krze geliefert."));
		assertTrue(stub.getMessages().
		           contains("Pizza Surprise wird in Krze geliefert."));
	}
}