package ch20_unittests.ch20_5_advanced.extractandoverride.step1_2;


import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.function.Executable;


/**
 * Testklasse fr die Klasse Calculator mit ExtractAndOverride
 * 
 * @author Michael Inden
 * 
 * Copyright 2017, 2019 by Michael Inden 
 */ 
public class CalculatorTestStep1_2
{
    @Test
    public void testCalc_TwoNumbers_ShouldReturnSum()
    {
        final Calculator calculator = new Calculator();
        assertEquals(5, calculator.calc("2", "3"));
    }

    @Test
    public void testCalc_WithEqualNumbersButDifferentSigns_ShouldReturn0()
    {
        final Calculator calculator = new Calculator();
        assertEquals(0, calculator.calc("7", "-7"));
    }
 
	@Test
	public void testCalc_IllegalInputs_ShouldRaiseException()
	{
	    final Calculator calculator = new Calculator()
	    {
	        protected void showWarning(final String message)
	        {
	            // JOptionPane.showConfirmDialog(null, message);
	            throw new IllegalArgumentException("Keine gltige Ganzzahl");
	        }
	    };
	    
	    final Executable calcInvalidInputs = 
	    		         () -> calculator.calc("a2", "b3");
	    
		assertThrows(IllegalArgumentException.class, 
	    		     calcInvalidInputs);
	}
}