package ch20_unittests.ch20_5_mockito.examples;

import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.atLeast;
import static org.mockito.Mockito.atMost;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

import org.junit.jupiter.api.Test;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class MockitoCallTimesExampleTest 
{
    @Test
    public void testGreetingCallCount() 
    {
        // Arrange
        final Greeting greeting = mock(Greeting.class);
        when(greeting.greet(anyString())).
                      thenReturn("Hello Mockito1", "Hello Mockito2");

        // Act
        final Application app = new Application(greeting);
        final String result1 = app.generateMsg("Tim");
        final String result2 = app.generateMsg("Mike");
        final String result3 = app.generateMsg("Tim");

        // Assert
        verify(greeting, atLeast(1)).greet("Tim");
        verify(greeting, atMost(2)).greet("Tim");
        verify(greeting, times(3)).greet(anyString());
    }
}