package ch20_unittests.ch20_5_mockito.examples_no_more_interactions;

import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.verifyNoMoreInteractions;
import static org.mockito.Mockito.when;

import org.junit.jupiter.api.Test;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class MockitoInteractionsExample 
{
    @Test
    public void testGreetingCallCount() 
    {
        // Arrange
        final Greeting greeting = mock(Greeting.class);
        when(greeting.greet(anyString())).thenReturn("The One and Only");

        // Act
        final Application app = new Application(greeting);
        app.specialMsg("HELLO");
        app.noCoveredByVerify();

        // Assert
        verify(greeting, times(1)).greet(anyString());
        verifyNoMoreInteractions(greeting);
    }
}