package ch20_unittests.ch20_5_mockito.examples_no_more_interactions;

import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.doAnswer;
import static org.mockito.Mockito.doThrow;

import java.util.Arrays;

import org.junit.jupiter.api.Test;
import org.mockito.Mockito;
import org.mockito.stubbing.Answer;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class MockitoVoidMethodExample
{
    @Test
    void testHandlingVoidMethods()
    {
        // Arrange
        final Greeting greeting = Mockito.mock(Greeting.class);
        
        final Answer<String> answer = (invocation) -> 
                                  { System.out.println("EXECUTING " +
                                    invocation.getMethod().getName() +
                                    Arrays.toString(invocation.getArguments()));
                                    return null;
                                  };
                                                                             
        doAnswer(answer).when(greeting).noReturnJustPrint(anyString());  
        doThrow(IllegalStateException.class).when(greeting).noReturnJustPrint("ERROR");     
     
        // Act
        greeting.noReturnJustPrint("Mike");    
        assertThrows(IllegalStateException.class,
   		     () -> greeting.noReturnJustPrint("ERROR"));   // => $\mbox{\bfseries Exception}$
    }
}