package ch20_unittests.ch20_5_mockito.intro;

import static org.junit.Assert.assertEquals;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

import org.junit.jupiter.api.Test;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class MockitoHelloWorldExample 
{
	@Test
	void testGreetingReturnValue()
	{
		// Arrange
		final Greeting greeting = mock(Greeting.class);
		when(greeting.greet()).thenReturn("Changed by Mockito");

		// Act
		final String result = greeting.greet();

		// Assert
		assertEquals("Changed by Mockito", result);
	}
}