package ch20_unittests.ch20_7_tools;

import static org.assertj.core.api.Assertions.assertThatExceptionOfType;
import static org.assertj.core.api.Assertions.assertThatThrownBy;

import java.io.IOException;

import org.assertj.core.api.ThrowableAssert.ThrowingCallable;
import org.junit.jupiter.api.Test;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class AssertJExceptionsTest
{
    @Test
    void testException()
    {
        ThrowingCallable action = () -> {
            throw new Exception("PENG!");
        };

        assertThatThrownBy(action).isInstanceOf(Exception.class).hasMessageContaining("PENG");
    }

    @Test
    void testException_2()
    {
        ThrowingCallable action = () -> {
            throw new IOException("PENG!");
        };

        assertThatExceptionOfType(IOException.class).isThrownBy(action).withMessage("%s!", "PENG")
                        .withMessageContaining("NG").withNoCause();
    }
}