package ch20_unittests.ch20_7_tools;

import static org.assertj.core.api.Assertions.assertThat;

import java.time.LocalDate;
import java.util.List;

import org.junit.jupiter.api.Test;

import ch03_oodesign.generics.Person;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class AssertJExtractionsTest
{
    @Test
    public void descriptionTest()
    {
        final Person tim = new Person("Tim", LocalDate.of(1971, 3, 27), "Kiel");

        assertThat(tim.getBirthday().getYear()).as("prfe Geburtsjahr").isEqualTo(1977);
        assertThat(tim.getCity()).as("prfe %s Stadt", tim).isEqualTo(("Kln"));
    }

    @Test
    public void extractionTest()
    {
        final Person tim = new Person("Tim", LocalDate.of(1971, 3, 27), "Kiel");
        final Person mike = new Person("Mike", LocalDate.of(1971, 2, 7), "Bremen");
        var persons = List.of(tim, mike);

        assertThat(persons).extracting("name").contains("Tim", "Mike").doesNotContain("Peter", "Franz");
    }
}