package ch20_unittests.ch20_7_tools;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class AssertJSpecialComparisionsTest
{
    public static class SimplePerson
    {
        private final String name;
        private final float  weight;
        private final int    age;

        public SimplePerson(String name, float weight, int age)
        {
            this.name = name;
            this.weight = weight;
            this.age = age;
        }
    }

    @Test
    void testAllAttributesEqual()
    {
        SimplePerson tim = new SimplePerson("tim", 111.11f, 49);
        SimplePerson tim2 = new SimplePerson("tim", 111.11f, 49);

        assertThat(tim).usingRecursiveComparison().isEqualTo(tim2);
    }

    @Test
    void testGivenAttributesEqual()
    {
        SimplePerson tim = new SimplePerson("tim", 111.11f, 49);
        SimplePerson tom = new SimplePerson("tom", 111.11f, 49);

        assertThat(tim).isEqualToComparingOnlyGivenFields(tom, "weight", "age");
    }

    @Test
    void testGivenAttributesEqual_Recommended()
    {
        SimplePerson tim = new SimplePerson("tim", 111.11f, 49);
        SimplePerson tom = new SimplePerson("tom", 111.11f, 49);

        assertThat(tim).usingRecursiveComparison().ignoringFields("name").isEqualTo(tom);
    }
}