package ch20_unittests.ch20_7_tools;

import org.hamcrest.Description;
import org.hamcrest.TypeSafeMatcher;

/**
 * Beispielimplementierung eines Hamcrest-Matchers fr gerade Zahlen  
 * 
 * @author Michael Inden
 * 
 * Copyright 2011, 2014 by Michael Inden 
 */
public class IsEvenNumber extends TypeSafeMatcher<Integer>
{
    @Override
    public boolean matchesSafely(final Integer number)
    {
        return number.intValue() % 2 == 0;
    }

    @Override
    public void describeTo(final Description description)
    {
        description.appendText("even number");
    }
    
    public static IsEvenNumber evenNumber() {
        return new IsEvenNumber();
    }
}
