package ch20_unittests.ch20_7_tools;

import static org.assertj.core.api.Assertions.assertThat;
import static org.junit.jupiter.api.Assertions.assertAll;

import org.junit.jupiter.api.Test;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class SimplePersonAssertJTest
{
    public static class Dog
    {
        private String name;
        private float  weight;

        public Dog(String name, float weight)
        {
            this.name = name;
            this.weight = weight;
        }
    }

    @Test
    public void testAttributesEqual()
    {
        Dog fido = new Dog("Fido", 5.25f);
        Dog fidosClone = new Dog("Fido", 5.25f);

        assertAll(() -> assertThat(fido).isNotEqualTo(fidosClone),
                  // aber ggf. Problem mit Floats
                  () -> assertThat(fido).usingRecursiveComparison());
    }

    @Test
    public void testAttributesEqual_Float()
    {
        Dog fido = new Dog("Fido", 5.25f);
        Dog fidosClone = new Dog("Fido", 5f + .13f + 0.1f);

        assertAll(() -> assertThat(fido).isNotEqualTo(fidosClone),
                  // aber ggf. Problem mit Floats
                  () -> assertThat(fido).usingRecursiveComparison());
    }
}