package ch20_unittests.ch20_8_migrationsupport;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

import ch20_unittests.ch20_3_misc.Controller;

/**
 * Unit-Tests zur Demonstration von Parametrized Tests
 * 
 * @author Michael Inden
 * 
 *         Copyright 2020 by Michael Inden
 */
public class ParametrizedTestReplacementInJUnit5Test 
{
	@ParameterizedTest(name = "{index}: hex {0} => dec {1}")
	@CsvSource({ "0, 0", "1, 1", "2, 2", "3, 3", "4, 4", 
		         "5, 5", "6, 6", "7, 7", "8, 8", "9, 9", 
		         "A, 10", "B, 11", "C, 12", "D, 13", "E, 14", "F, 15" })
	void testHexToDec(final char hexDigit, final int expected) {
		final int result = Controller.hexCodedByteValueToInt((byte) hexDigit);

		assertEquals(expected, result);
	}
}