package ch20_unittests.ch20_8_migrationsupport;
import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.File;
import java.io.IOException;
import java.util.Set;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.io.TempDir;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class TemporaryFolderReplacementInJUnit5Test
{
   @Test
   public void testUsingTempFolder(@TempDir File folder) throws IOException 
   {
      final File subFolder = new File(folder, "subfolder");
      subFolder.mkdir();
      final File createdFile = new File(folder, "abc.txt");
      createdFile.createNewFile();
      
      // Ermittle den Inhalt des Temp-Folders, normales File-API  
      final String[] dirContents = folder.list();
		    
      // Prfe, ob File existiert und Verzeichnisinhalt bereinstimmt 
      assertTrue(createdFile.exists());

      // assertEquals() auf Set damit die Reihenfolge keinen Einfluss hat  
      assertEquals(Set.of("subfolder", "abc.txt"), Set.of(dirContents));
   }
}