package ch20_unittests.ch20_8_migrationsupport;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.io.File;
import java.io.IOException;
import java.util.Set;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.TemporaryFolder;

/**
 * Unit-Tests zur Demonstration der JUnit Rule TemporaryFolder
 * 
 * @author Michael Inden
 * 
 * Copyright 2014, 2017, 2020 by Michael Inden
 */
public class TemporaryFolderTest 
{
   @Rule
   public TemporaryFolder folder = new TemporaryFolder();

   @Test
   public void testUsingTempFolder() throws IOException 
   {
      // Ermittle den Inhalt des Temp-Folders, normales File-API 
      final String[] dirContentsInitial = folder.getRoot().list();
      assertEquals(0, dirContentsInitial.length);

      final File subFolder = folder.newFolder("subfolder");
      final File createdFile = folder.newFile("abc.txt");

      // Ermittle den Inhalt des Temp-Folders, normales File-API  
      final String[] dirContents = folder.getRoot().list();
		
      // Als Menge, damit die Reihenfolge keinen Einfluss hat 
      assertEquals(Set.of("subfolder", "abc.txt"), Set.of(dirContents));

      // Prfe, ob File existiert  
      assertTrue(createdFile.exists());
   }
}