package ch20_unittests.ch20_8_migrationsupport;

import static org.junit.jupiter.api.Assertions.assertTimeout;
import static org.junit.jupiter.api.Assertions.assertTimeoutPreemptively;

import java.time.Duration;
import java.time.temporal.ChronoUnit;
import java.util.concurrent.TimeUnit;

import org.junit.jupiter.api.Test;

/**
 * Besipiel fr das Buch "Der Weg zum Java-Profi 5"
 * 
 * @author Michael Inden
 * 
 * Copyright 2020 by Michael Inden 
 */
public class TimeoutReplacementInJUnit5Test
{
    @Test
    void testAssertTimeout()
    {
        assertTimeout(Duration.of(500, ChronoUnit.MILLIS), 
                      () -> longRunningAction());
    }

    @Test
    void testAssertTimeoutPreemptively()
    {
        assertTimeoutPreemptively(Duration.of(2, ChronoUnit.SECONDS), 
                                  () -> loopForever());
    }

    
    private void longRunningAction() throws InterruptedException
    {
        for (int i = 0; i < 20; i++)
        {
            TimeUnit.MILLISECONDS.sleep(250);
        }
    }

    private void loopForever() throws InterruptedException
    {
        for (;;)
        {
            TimeUnit.SECONDS.sleep(1);
        }
    }
}